#include <cmath>
#include <iostream>
#include <cstdio>
#include <cstdlib>

#include "myio.h"
#include "mylib.h"

using namespace std;

int main(int argc,char **argv){
    myio_init(argc,argv);

    int nx,nz;
    float ox,oz,dx,dz;

    get_param("nx",nx,"ox",ox,"dx",dx);
    get_param("nz",nz,"oz",oz,"dz",dz);

    long long nxz=nx*nz;
    float dx2=dx*dx,dz2=dz*dz;

    float v1,v2,v3,v4,depth12,depth34;
    get_param("v1",v1,"v2",v2,"depth12",depth12);
    get_param("v3",v3,"v4",v4,"depth34",depth34);
    int idepth12=(depth12-oz)/dz+1;
    int idepth34=(depth34-oz)/dz+1;

    float *v=new float[nxz];

    set(v,v1,nx*idepth12);
    
    float a=(v3-v2)/((float)idepth34-1.-(float)idepth12);
    #pragma omp parallel for
    for(int iz=idepth12;iz<idepth34;iz++) set(v+nx*iz,(iz-idepth12)*a+v2,nx);
    
    set(v+nx*idepth34,v4,nx*(nz-idepth34));

    float dv,topdv,botdv;
    get_param("dv",dv,"topdv",topdv,"botdv",botdv);
    int itop=(topdv-oz)/dz+1;
    int ibot=(botdv-oz)/dz+1;
    #pragma omp parallel for
    for(int iz=itop;iz<ibot;iz++){
        for(int ix=0;ix<nx;ix++){
            v[ix+iz*nx]+=dv;
        }
    }

    write("v",v,nxz);

    to_header("v","n1",nx,"o1",ox,"d1",dx);
    to_header("v","n2",nz,"o2",oz,"d2",dz);

    myio_close();
    return 0;
}
