#ifndef WAVE_H
#define WAVE_H

void synthetic_f(float *d,const float *c11,const float *c13,const float *c33,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float ot=0.);

void rtm_f(float *image,const float *data,const float *c11,const float *c13,const float *c33,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float ot=0.);

float objFuncGradientCij(float *gc11,float *gc13,float *gc33,const float *data,float *c11,float *c13,float *c33,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float ot,float wbottom,float *m);

float objFuncGradientVEpsDel(float *gv,float *geps,float *gdel,const float *data,float *v,float *eps,float *del,float v0,float eps0,float del0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float ot,float wbottom,float *m);

float objFuncGradient_f(float *gc11,float *gc13,float *gc33,const float *data,const float *c11,const float *c13,const float *c33,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float ot=0.);

void modeling_f(float *d,const float *c11,const float *c13,const float *c33,const float *wavelet,int slocxz,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float ot=0.);

void odcig_f(float *image,const float *data,const float *c11,const float *c13,const float *c33,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nhx,int nt,int npad,float dx,float dz,float dt,float rate,float ot=0.);

float objFuncGradientRFWI_f(float *gc11,float *gc13,float *gc33,const float *data,const float *c11,const float *c13,const float *c33,const float *dc11,const float *dc13,const float *dc33,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float ot);

float objFuncGradientRFWICij(float *gc11,float *gc13,float *gc33,const float *d0,float *c11,float *c13,float *c33,float *dc11,float *dc13,float *dc33,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float ot,float wbottom,float *m);

float objFuncGradientRFWIVEpsDel(float *gv,float *geps,float *gdel,const float *d0,float *v,float *eps,float *del,float *dv,float *deps,float *ddel,float v0,float eps0,float del0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float ot,float wbottom,float *m);

void waveletGradient_f(float *gwavelet,const float *d0,const float *c11,const float *c13,const float *c33,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate);

 
#endif
